package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: QueryType
// UnionValue: TxId

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RequestByTxId")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RequestByTxId implements Marshallable {
	public final QueryType type = QueryType.TX_ID;
	private byte[] txId;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getTxId() {
	    return txId;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setTxId(final byte[] value) {
	    this.txId = value;
	}

	public RequestByTxId txId(final byte[] value) {
	    setTxId(value);
	    return this;
	}
	public RequestByTxId txId(final String value) {
		try {
			setTxId(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.txId == null || this.txId.length == 0)) {
            marshaller.writeHash(2, this.txId);
        }
        return marshaller.array();
    }
}
